// ET199.h : Declaration of the CET199

#ifndef __ET199_H_
#define __ET199_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CET199
class ATL_NO_VTABLE CET199 : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IET199, &IID_IET199, &LIBID_ET199APPLib>,
	public CComControl<CET199>,
	public IPersistStreamInitImpl<CET199>,
	public IOleControlImpl<CET199>,
	public IOleObjectImpl<CET199>,
	public IOleInPlaceActiveObjectImpl<CET199>,
	public IViewObjectExImpl<CET199>,
	public IOleInPlaceObjectWindowlessImpl<CET199>,
	public IPersistStorageImpl<CET199>,
	public ISpecifyPropertyPagesImpl<CET199>,
	public IQuickActivateImpl<CET199>,
	public IDataObjectImpl<CET199>,
	public IProvideClassInfo2Impl<&CLSID_ET199, NULL, &LIBID_ET199APPLib>,
	public CComCoClass<CET199, &CLSID_ET199>,
	public IObjectSafetyImpl<CET199,INTERFACESAFE_FOR_UNTRUSTED_CALLER>
{
public:
	CET199()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ET199)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CET199)
	COM_INTERFACE_ENTRY(IET199)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_PROP_MAP(CET199)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CET199)
	CHAIN_MSG_MAP(CComControl<CET199>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IET199
public:
	STDMETHOD(TDESDecrypt)(/*[in]*/ BSTR bstrInData, /*[out, retval]*/ BSTR *bstrOutData);
	STDMETHOD(TDESEncrypt)(/*[in]*/ BSTR bstrInData, /*[out, retval]*/ BSTR *bstrOutData);
	STDMETHOD(SetTDESKey)(/*[in]*/ BSTR pbTDesKey, /*[out, retval]*/ long *lRet);
	STDMETHOD(RSADecrypt)(/*[in]*/ BSTR bstrInData, /*[out, retval]*/ BSTR *bstrOutData);
	STDMETHOD(RSAEncrypt)(/*[in]*/ BSTR bstrInData, /*[out, retval]*/ BSTR *bstrOutData);
	STDMETHOD(Read)(/*[in]*/ WORD Offset, /*[in]*/ BYTE bLen, /*[out, retval]*/ BSTR *bstrData);
	STDMETHOD(Write)(/*[in]*/ DWORD dwOffset, /*[in]*/ DWORD dwLen, /*[in]*/ BSTR bstrData, /*[out, retval]*/ long *lRet);
	STDMETHOD(VerifyPIN)(/*[in]*/ DWORD dwFlags, /*[in]*/ BSTR pbPIN, /*[out, retval]*/ long *lRet);
	STDMETHOD(Open)(/*[out, retval]*/ long *lRet);
	STDMETHOD(Enum)(/*[out, retval]*/ DWORD *dwCount);
	STDMETHOD(GetSN)(/*[out, retval]*/ BSTR *pVal);

//	HRESULT OnDraw(ATL_DRAWINFO& di)
//	{
//		RECT& rc = *(RECT*)di.prcBounds;
//		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
//
//		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
//		LPCTSTR pszText = _T("ATL 3.0 : ET199");
//		TextOut(di.hdcDraw, 
//			(rc.left + rc.right) / 2, 
//			(rc.top + rc.bottom) / 2, 
//			pszText, 
//			lstrlen(pszText));
//
//		return S_OK;
//	}
};

#endif //__ET199_H_
